
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class DebtsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const debts = await db.debts.create(
            {
                id: data.id || undefined,
        
        debt_code: data.debt_code
        ||
        null
            ,
            
        creditor_name: data.creditor_name
        ||
        null
            ,
            
        creditor_document: data.creditor_document
        ||
        null
            ,
            
        description_text: data.description_text
        ||
        null
            ,
            
        balance_previous_year: data.balance_previous_year
        ||
        null
            ,
            
        balance_current_year: data.balance_current_year
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await debts.setDeclaration( data.declaration || null, {
            transaction,
        });
        
        await debts.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return debts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const debtsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                debt_code: item.debt_code
            ||
            null
            ,
            
                creditor_name: item.creditor_name
            ||
            null
            ,
            
                creditor_document: item.creditor_document
            ||
            null
            ,
            
                description_text: item.description_text
            ||
            null
            ,
            
                balance_previous_year: item.balance_previous_year
            ||
            null
            ,
            
                balance_current_year: item.balance_current_year
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const debts = await db.debts.bulkCreate(debtsData, { transaction });

        // For each item created, replace relation files
        

        return debts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const debts = await db.debts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.debt_code !== undefined) updatePayload.debt_code = data.debt_code;
        
        
        if (data.creditor_name !== undefined) updatePayload.creditor_name = data.creditor_name;
        
        
        if (data.creditor_document !== undefined) updatePayload.creditor_document = data.creditor_document;
        
        
        if (data.description_text !== undefined) updatePayload.description_text = data.description_text;
        
        
        if (data.balance_previous_year !== undefined) updatePayload.balance_previous_year = data.balance_previous_year;
        
        
        if (data.balance_current_year !== undefined) updatePayload.balance_current_year = data.balance_current_year;
        
        
        updatePayload.updatedById = currentUser.id;

        await debts.update(updatePayload, {transaction});

        
        
        if (data.declaration !== undefined) {
            await debts.setDeclaration(
              
              data.declaration,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await debts.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return debts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const debts = await db.debts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of debts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of debts) {
                await record.destroy({transaction});
            }
        });


        return debts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const debts = await db.debts.findByPk(id, options);

        await debts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await debts.destroy({
            transaction
        });

        return debts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const debts = await db.debts.findOne(
            { where },
            { transaction },
        );

        if (!debts) {
            return debts;
        }

        const output = debts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.declaration = await debts.getDeclaration({
            transaction
        });
        
        
        output.organizations = await debts.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.declarations,
        as: 'declaration',
        
        where: filter.declaration ? {
          [Op.or]: [
            { id: { [Op.in]: filter.declaration.split('|').map(term => Utils.uuid(term)) } },
            {
              status: {
                [Op.or]: filter.declaration.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.debt_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'debts',
                        'debt_code',
                        filter.debt_code,
                    ),
                };
            }
            
            if (filter.creditor_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'debts',
                        'creditor_name',
                        filter.creditor_name,
                    ),
                };
            }
            
            if (filter.creditor_document) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'debts',
                        'creditor_document',
                        filter.creditor_document,
                    ),
                };
            }
            
            if (filter.description_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'debts',
                        'description_text',
                        filter.description_text,
                    ),
                };
            }
            

            
            

            
            if (filter.balance_previous_yearRange) {
                const [start, end] = filter.balance_previous_yearRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    balance_previous_year: {
                    ...where.balance_previous_year,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    balance_previous_year: {
                    ...where.balance_previous_year,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.balance_current_yearRange) {
                const [start, end] = filter.balance_current_yearRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    balance_current_year: {
                    ...where.balance_current_year,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    balance_current_year: {
                    ...where.balance_current_year,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.debts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'debts',
                        'creditor_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.debts.findAll({
            attributes: [ 'id', 'creditor_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['creditor_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.creditor_name,
        }));
    }

    
};

